unit unBackgroundDM;

interface

uses
  SysUtils, Classes, DB, IBCustomDataSet, IBQuery, IBDatabase, IBStoredProc;

type
  TBackgroundDM = class(TDataModule)
    Transaction: TIBTransaction;
    SetNewGenerationProc: TIBStoredProc;
    ClearLogsProc: TIBStoredProc;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetNewGeneration;
    procedure ClearLogs;
  end;

var
  BackgroundDM: TBackgroundDM;

implementation

uses unClientMainDM;

{$R *.dfm}

{ TBackgroundDM }


procedure TBackgroundDM.SetNewGeneration;
  begin
    Transaction.StartTransaction;
    try
      SetNewGenerationProc.ExecProc;
      Transaction.Commit;
    except
      Transaction.Rollback;
      raise;
    end;
  end;

procedure TBackgroundDM.ClearLogs;
  begin
    Transaction.StartTransaction;
    try
      ClearLogsProc.ExecProc;
      Transaction.Commit;
    except
      Transaction.Rollback;
      raise;
    end;

  end;


end.
