unit unClientDataDM;

interface

uses
  SysUtils, Classes, IBCustomDataSet, IBUpdateSQL, DB, IBTable, IBDatabase,
  IBQuery;

type
  TClientDataDM = class(TDataModule)
    Master: TIBTable;
    Transaction: TIBTransaction;
    Query: TIBQuery;
    LogMaster: TIBTable;
    Detail: TIBTable;
    LogDetail: TIBTable;
    MasterGID: TLargeintField;
    MasterDATA: TIBStringField;
    MasterLOG_OWN_GEN: TIntegerField;
    DetailGID: TLargeintField;
    DetailDATA: TIBStringField;
    DetailMASTER_GID: TLargeintField;
    DetailLOG_OWN_GEN: TIntegerField;
    LogMasterLOG_GID: TLargeintField;
    LogMasterLOG_INS_GEN: TIntegerField;
    LogMasterLOG_UPD_GEN: TIntegerField;
    LogMasterLOG_IS_DELETED: TLargeintField;
    LogMasterLOG_DB_ID: TLargeintField;
    LogDetailLOG_GID: TLargeintField;
    LogDetailLOG_INS_GEN: TIntegerField;
    LogDetailLOG_UPD_GEN: TIntegerField;
    LogDetailLOG_IS_DELETED: TLargeintField;
    LogDetailLOG_DB_ID: TLargeintField;
    Client: TIBTable;
    DBProfile: TIBTable;
    LogDBProfile: TIBTable;
    procedure MasterAfterPost(DataSet: TDataSet);
    procedure MasterAfterDelete(DataSet: TDataSet);
    procedure DetailAfterDelete(DataSet: TDataSet);
    procedure DetailAfterPost(DataSet: TDataSet);
    procedure LogMasterLOG_GIDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure MasterGIDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure LogDetailLOG_GIDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure DetailGIDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure DetailMASTER_GIDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure RefreshAll;
  end;

var
  ClientDataDM: TClientDataDM;

implementation

uses
 unClientMainDM, unTools;

{$R *.dfm}


{ TServerDataDM }


procedure TClientDataDM.RefreshAll;
 begin
   Transaction.Active := false;
   Transaction.Active := true;

   (***Scema specific***)
   Master.Open;
   Detail.Open;
   LogMaster.Open;
   LogDetail.Open;
   (***/Scema specific***)
   DBProfile.Open;
   LogDBProfile.Open;
   Client.Open;
 end;

procedure TClientDataDM.MasterAfterPost(DataSet: TDataSet);
  begin
    Transaction.CommitRetaining;
    Master.Refresh;
    LogMaster.Refresh;
  end;

procedure TClientDataDM.MasterAfterDelete(DataSet: TDataSet);
  begin
    Transaction.CommitRetaining;
    Master.Refresh;
    LogMaster.Refresh;
  end;



procedure TClientDataDM.DetailAfterPost(DataSet: TDataSet);
  begin
    Transaction.CommitRetaining;
    Detail.Refresh;
    LogDetail.Refresh;
  end;

procedure TClientDataDM.DetailAfterDelete(DataSet: TDataSet);
  begin
    Transaction.CommitRetaining;
    Detail.Refresh;
    LogDetail.Refresh;
  end;

procedure TClientDataDM.LogMasterLOG_GIDGetText
  (
    Sender: TField;
    var Text: String;
    DisplayText: Boolean
  );
  begin
    if DisplayText then
      Text := GIDToStr( Sender.AsVariant );
  end;

procedure TClientDataDM.MasterGIDGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
  begin
    if DisplayText then
      Text := GIDToStr( Sender.AsVariant );
  end;

procedure TClientDataDM.LogDetailLOG_GIDGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
  begin
    if DisplayText then
      Text := GIDToStr( Sender.AsVariant );
  end;

procedure TClientDataDM.DetailGIDGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
  begin
    if DisplayText then
      Text := GIDToStr( Sender.AsVariant );
  end;

procedure TClientDataDM.DetailMASTER_GIDGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
  begin
    if DisplayText then
      Text := GIDToStr( Sender.AsVariant );
  end;

end.



