unit unGenDBIDDM;

interface

uses
  SysUtils, Classes, IBDatabase, DB, IBCustomDataSet, IBQuery;

type
  TGenDBIDDM = class(TDataModule)
    Database: TIBDatabase;
    Transaction: TIBTransaction;
    NewDBID: TIBQuery;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Open(const GenDBIDFileName: string);
    procedure Close;
    function GetNewDBID: Integer;
  end;

var
  GenDBIDDM: TGenDBIDDM;

implementation

{$R *.dfm}

procedure TGenDBIDDM.Open(const GenDBIDFileName: string);
  begin
    Database.DatabaseName := GenDBIDFileName;
    Database.Open;
  end;

procedure TGenDBIDDM.Close;
  begin
    Database.Close;
  end;

function TGenDBIDDM.GetNewDBID: Integer;
  begin
    Transaction.StartTransaction;
    try
      NewDBID.Open;
      try
        NewDBID.First;
        Result := NewDBID.FieldByName( 'DB_ID' ).AsInteger;
        NewDBID.Next;
        if not NewDBID.Eof then
            raise Exception.Create( 'TClientMainDM.GetNewDBID' );
      finally
        NewDBID.Close;
      end;
      Transaction.Commit;
    except
      Transaction.Rollback;
      raise;
    end;
  end;


end.
