unit unTestForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, IBCustomDataSet, IBQuery, IBDatabase, Spin,
  ExtCtrls;

type
  TTestForm = class(TForm)
    Transaction: TIBTransaction;
    Query: TIBQuery;
    Timer: TTimer;
    sedRecNum: TSpinEdit;
    sedInterval: TSpinEdit;
    lbxLog: TListBox;
    cbxActivated: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure TimerTimer(Sender: TObject);
    procedure cbxActivatedClick(Sender: TObject);
    procedure sedIntervalChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure AddLog(const Str: string);
    procedure AddLogFmt(const FormatStr: string;
      const Args: array of TVarRec);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

uses unClientMainDM;

{$R *.dfm}

procedure TTestForm.TimerTimer(Sender: TObject);
  var
    j: Integer;
    CurrDBID: Integer;
  begin
    CurrDBID := ClientMainDM.GetCurrDBID;
    Transaction.StartTransaction;
    try
      for j := 1 to sedRecNum.Value do
        begin
          Query.SQL.Text := Format( 'insert into MASTER( DATA ) values ( ''%s(%d)'' )', [ TimeToStr( Now ), CurrDBID ] );
          Query.ExecSQL;
        end;
      Transaction.Commit;
      AddLogFmt( '%d records were inserted', [ sedRecNum.Value ] );
    except
      Transaction.Rollback;
      raise;
    end;
  end;


procedure TTestForm.AddLog(const Str: string);
  var
    i: Integer;
  begin
    lbxLog.Items.Insert( 0, '[' + TimeToStr( Now ) + '] ' + Str );
    lbxLog.ItemIndex := 0;
    if lbxLog.Items.Count > 2000 then
      for i := lbxLog.Items.Count - 1 downto lbxLog.Items.Count div 2 do
        lbxLog.Items.Delete( i );
  end;

procedure TTestForm.AddLogFmt( const FormatStr: string; const Args: array of TVarRec );
  begin
    AddLog( Format( FormatStr, Args ) );
  end;



procedure TTestForm.cbxActivatedClick(Sender: TObject);
  begin
    Timer.Enabled := cbxActivated.Checked;
  end;

procedure TTestForm.sedIntervalChange(Sender: TObject);
  begin
    Timer.Interval := sedInterval.Value * 1000;
  end;

procedure TTestForm.FormCreate(Sender: TObject);
  begin
    Timer.Enabled := cbxActivated.Checked;
    Timer.Interval := sedInterval.Value * 1000;
  end;

end.
