(****************************************************************)
(* TMainForm -   .                       *)
(*   ForceSetNewGenMsg,    *)
(*  Backgrounds           *)
(* ( Backgrounds.exe    ) *)
(****************************************************************)
unit unMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ActnList, ExtCtrls;

type
  TMainForm = class(TForm)
    btOpenDatabase: TButton;
    PageControl: TPageControl;
    btAddServer: TButton;
    ActionList1: TActionList;
    actOpenDatabase: TAction;
    actAddServer: TAction;
    pnControls: TPanel;
    lbxLog: TListBox;
    OpenServerDialog: TOpenDialog;
    OpenDatabaseDialog: TOpenDialog;
    btDeleteServer: TButton;
    actDeleteServer: TAction;
    cbxConfirmReceive: TCheckBox;
    procedure actAddServerExecute(Sender: TObject);
    procedure actOpenDatabaseExecute(Sender: TObject);
    procedure actDeleteServerExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure FrameLog(Sender: TObject; const LogStr: string);
    procedure RefreshCaption;
  public
    { Public declarations }
    procedure RemoteDMBeforeCommitReceiveGen( Sender: TObject; Gen: Integer );
    procedure RemoteDMAfterCommitReceiveGen( Sender: TObject; Gen: Integer );
  end;

var
  MainForm: TMainForm;

implementation

uses unTabFrame, unClientMainDM, unServerMainDM, unGlobal,
  unServerChangesForm, unInteractionDM;

{$R *.dfm}

procedure TMainForm.FrameLog( Sender: TObject; const LogStr: string);
  var
    i: Integer;
  begin
    lbxLog.Items.Insert( 0, '[' + TimeToStr( Now ) + '] ' + LogStr );
    lbxLog.ItemIndex := 0;
    if lbxLog.Items.Count > 2000 then
      for i := lbxLog.Items.Count - 1 downto lbxLog.Items.Count div 2 do
        lbxLog.Items.Delete( i );
  end;



procedure TMainForm.actAddServerExecute(Sender: TObject);
  var
    Tab: TTabSheet;
    Frame: TTabFrame;
  begin
    if OpenServerDialog.Execute then
      begin
        ServerMainDM.Open( OpenServerDialog.FileName );
        try
          Tab := TTabSheet.Create( PageControl );
          Frame := TTabFrame.Create( Tab );
          Frame.OnLog := FrameLog;
          Frame.DatabaseName := OpenServerDialog.FileName;
          Frame.DBID := ServerMainDM.GetCurrDBID;
          Frame.Parent := Tab;
          Tab.Caption := IntToStr( Frame.DBID );
          Tab.Parent := PageControl;
          Tab.PageControl := PageControl;
          PageControl.ActivePage := Tab;
        finally
          ServerMainDM.Close;
        end;
      end;
  end;


procedure TMainForm.RefreshCaption;
 var
   CurrDBID: Integer;
   CurrGen:  Integer;
   DatabaseName: string;
 begin
   CurrDBID :=  ClientMainDM.GetCurrDBID;
   CurrGen  :=  ClientMainDM.GetCurrGen;
   DatabaseName := ClientMainDM.DatabaseName;
   Caption := Format( 'DB: %d GEN: %d [%s]', [ CurrDBID, CurrGen, DatabaseName ] );
 end;


procedure TMainForm.actOpenDatabaseExecute(Sender: TObject);
  begin
    if OpenDatabaseDialog.Execute then
      begin
        ClientMainDM.Open( OpenDatabaseDialog.FileName );
        RefreshCaption;
      end;
  end;

procedure TMainForm.actDeleteServerExecute(Sender: TObject);
  begin
    PageControl.ActivePage.Free;
  end;


procedure ForceSetNewGenMsgSender( h: HWND; lParam: LPARAM ); stdcall;
  begin
    //  ForceSetNewGenMsg  h. lParam     id  .
    //    Backgrounds.exe,    .
    PostMessage( h, ForceSetNewGenMsg, 0, lParam );
  end;

procedure TMainForm.RemoteDMAfterCommitReceiveGen(Sender: TObject; Gen: Integer);
  begin
    //       ForceSetNewGenMsgSender  lParam  id  
    //(HWND_BROADCAST -  )
    EnumWindows( @ForceSetNewGenMsgSender, ClientMainDM.GetCurrDBID );
  end;

procedure TMainForm.RemoteDMBeforeCommitReceiveGen(Sender: TObject;  Gen: Integer);
  begin
    if cbxConfirmReceive.Checked then
      if ServerChangesForm.ShowModalParams( gen ) = mrCancel then
        ABORT;
  end;

procedure TMainForm.FormShow(Sender: TObject);
  begin
    InteractionDM.OnBeforeCommitReceiveGen := RemoteDMBeforeCommitReceiveGen;
    InteractionDM.OnAfterCommitReceiveGen := RemoteDMAfterCommitReceiveGen;
  end;

end.
